#!/usr/bin/python2
# Modified build.py for use with GNU/Linux by tomiga

import sys
import os
import ftplib


BASE_ADDRESS = 0x080C3EE0
CC = "arm-eabi-gcc"
CP = "arm-eabi-g++"
OC = "arm-eabi-objcopy"
LD = "arm-eabi-ld"


def run(cmd):
	#print cmd
	os.system(cmd)

def upload(filename):  #used by original author for transfering binary to SD wirelessly -not used here
	session = ftplib.FTP('192.168.2.29')
	file = open(filename,"rb")
	session.storbinary('STOR '+filename, file)
	file.close()
	session.quit()

cwd = os.getcwd()
run("rm obj/*.o")
run(CC+" -g source/*.c -c -mcpu=mpcore -march=armv6k -mlittle-endian");
run(CC+" -g source/*.s -c -mcpu=mpcore -march=armv6k -mlittle-endian");
run("cp -r *.o obj/ > /dev/null")
run(LD+" -T 3ds.ld *.o")
run("cp a.out bin/homebrew.elf > /dev/null")
run(OC+" -O binary a.out payload.bin")
run(cwd+"/lib/p3ds/3dsploit.py "+cwd+"payload.bin > /dev/null")
#run("copy Launcher.dat E:\\Launcher.dat > NUL") not needed
#upload("Launcher.dat") not needed
run("rm *.o")
run("rm *.out")
#run("del payload.bin") doesn't hurt to leave this
